"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _reactDom = _interopRequireDefault(require("react-dom"));

var _minimongo = _interopRequireDefault(require("@nyby/minimongo"));

var _Tracker = _interopRequireDefault(require("./Tracker"));

var _setImmediateShim = _interopRequireDefault(require("set-immediate-shim"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

process.nextTick = _setImmediateShim["default"];
var db = new _minimongo["default"]();
db.debug = false;
db.batchedUpdates = _reactDom["default"].unstable_batchedUpdates;

function runAfterOtherComputations(fn) {
  _Tracker["default"].afterFlush(function () {
    return fn();
  });
}

var _default = {
  _endpoint: null,
  _options: {},
  ddp: null,
  subscriptions: {},
  db: db,
  calls: [],
  getUrl: function getUrl() {
    return this._endpoint.substring(0, this._endpoint.indexOf('/websocket'));
  },
  waitDdpReady: function waitDdpReady(cb) {
    var _this = this;

    if (this.ddp) {
      cb();
    } else {
      runAfterOtherComputations(function () {
        return _this.waitDdpReady(cb);
      });
    }
  },
  _cbs: [],
  onChange: function onChange(cb) {
    this.db.on('change', cb);
    this.ddp.on('connected', cb);
    this.ddp.on('disconnected', cb);
    this.on('loggingIn', cb);
    this.on('change', cb);
  },
  offChange: function offChange(cb) {
    this.db.off('change', cb);
    this.ddp.off('connected', cb);
    this.ddp.off('disconnected', cb);
    this.off('loggingIn', cb);
    this.off('change', cb);
  },
  on: function on(eventName, cb) {
    this._cbs.push({
      eventName: eventName,
      callback: cb
    });
  },
  off: function off(eventName, cb) {
    this._cbs.splice(this._cbs.findIndex(function (_cb) {
      return _cb.callback === cb && _cb.eventName === eventName;
    }), 1);
  },
  notify: function notify(eventName) {
    this._cbs.map(function (cb) {
      if (cb.eventName === eventName && typeof cb.callback == 'function') {
        cb.callback();
      }
    });
  },
  waitDdpConnected: function waitDdpConnected(cb) {
    var _this2 = this;

    if (this.ddp && this.ddp.status === 'connected') {
      cb();
    } else if (this.ddp) {
      this.ddp.once('connected', cb);
    } else {
      setTimeout(function () {
        return _this2.waitDdpConnected(cb);
      }, 10);
    }
  }
};
exports["default"] = _default;