"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _Meteor = _interopRequireDefault(require("../Meteor"));

var _ejson = _interopRequireDefault(require("ejson"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function paramsForSub(params) {
  if (Array.isArray(params)) {
    return params;
  }

  return typeof params === 'undefined' ? [] : [params];
}

function findExistingSubscriptionId(name, params) {
  return (0, _lodash.findKey)(_Meteor["default"].getData().subscriptions, {
    name: name,
    params: _ejson["default"].clone(paramsForSub(params))
  });
}

function info(msg) {
  console.info("Pub: ".concat(msg));
}

var Pub = /*#__PURE__*/function () {
  function Pub() {
    _classCallCheck(this, Pub);

    _defineProperty(this, "subs", {});
  }

  _createClass(Pub, [{
    key: "_debugRefs",
    value: function _debugRefs(id) {
      if (this.subs[id]) {
        return "subId=".concat(id, ", refs(").concat(this.subs[id].refs.length, ")=").concat(this.subs[id].refs);
      }

      return 'not found';
    }
  }, {
    key: "subscribe",
    value: function subscribe(name, params, refId) {
      var id = findExistingSubscriptionId(name, params);

      if (!id || !this.subs[id]) {
        if (_Meteor["default"].isVerbose()) {
          var p = JSON.stringify(params);
          info("New subscription ".concat(name, "(").concat(p, "), refId=").concat(refId));
        }

        var subscription = _Meteor["default"].subscribe.apply(_Meteor["default"], [name].concat(_toConsumableArray(paramsForSub(params))));

        id = subscription.subscriptionId;
        this.subs[id] = {
          subscription: subscription,
          refs: []
        };
      } else if (id) {
        if (_Meteor["default"].isVerbose()) {
          var _p = JSON.stringify(params);

          info("Existing subscription ".concat(name, "(").concat(_p, "), subId=").concat(id, ", refId=").concat(refId));
        }
      }

      this.subs[id].refs = (0, _lodash.uniq)([].concat(_toConsumableArray(this.subs[id].refs), [refId]));

      if (_Meteor["default"].isVerbose()) {
        info("Subscribe ".concat(this._debugRefs(id)));
      }

      return this.subs[id].subscription;
    }
  }, {
    key: "stop",
    value: function stop(subscription, refId) {
      var id = subscription.subscriptionId;

      if (!id || !this.subs[id]) {
        return;
      }

      this.subs[id].refs = this.subs[id].refs.filter(function (i) {
        return i !== refId;
      });

      if (_Meteor["default"].isVerbose()) {
        info("Stop subscription ".concat(this._debugRefs(id)));
      }

      if (this.subs[id].refs.length === 0) {
        if (_Meteor["default"].isVerbose()) {
          info("Pub: Delete subscription subId=".concat(id));
        }

        delete this.subs[id];
        subscription.stop();
      }
    }
  }]);

  return Pub;
}();

var _default = new Pub();

exports["default"] = _default;