"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _wolfy87Eventemitter = _interopRequireDefault(require("wolfy87-eventemitter"));

var _queue = _interopRequireDefault(require("./queue"));

var _socket = _interopRequireDefault(require("./socket"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _get() { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(arguments.length < 3 ? target : receiver); } return desc.value; }; } return _get.apply(this, arguments); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DDP_VERSION = '1';
var PUBLIC_EVENTS = [// Subscription messages
'ready', 'nosub', 'added', 'changed', 'removed', // Method messages
'result', 'updated', // Error messages
'error'];
var DEFAULT_RECONNECT_INTERVAL = 10000;

var DDP = /*#__PURE__*/function (_EventEmitter) {
  _inherits(DDP, _EventEmitter);

  var _super = _createSuper(DDP);

  function DDP(options) {
    var _this;

    _classCallCheck(this, DDP);

    _this = _super.call(this);
    _this.status = 'disconnected'; // Default `autoConnect` and `autoReconnect` to true

    _this.autoConnect = options.autoConnect !== false;
    _this.autoReconnect = options.autoReconnect !== false;
    _this.reconnectInterval = options.reconnectInterval || DEFAULT_RECONNECT_INTERVAL;
    _this.messageQueue = new _queue["default"](function (message) {
      if (_this.status === 'connected') {
        _this.socket.send(message);

        return true;
      }

      return false;
    });
    _this.socket = new _socket["default"](options.SocketConstructor, options.endpoint);

    _this.socket.on('open', function () {
      // When the socket opens, send the `connect` message
      // to establish the DDP connection
      _this.socket.send({
        msg: 'connect',
        version: DDP_VERSION,
        support: [DDP_VERSION]
      });
    });

    _this.socket.on('close', function () {
      _this.status = 'disconnected';

      _this.messageQueue.empty();

      _this.emit('disconnected');

      if (_this.autoReconnect) {
        // Schedule a reconnection
        setTimeout(_this.socket.open.bind(_this.socket), _this.reconnectInterval);
      }
    });

    _this.socket.on('message:in', function (message) {
      if (message.msg === 'connected') {
        _this.status = 'connected';

        _this.messageQueue.process();

        _this.emit('connected');
      } else if (message.msg === 'ping') {
        // Reply with a `pong` message to prevent the server from
        // closing the connection
        _this.socket.send({
          msg: 'pong',
          id: message.id
        });
      } else if (PUBLIC_EVENTS.includes(message.msg)) {
        _this.emit(message.msg, message);
      }
    });

    if (_this.autoConnect) {
      _this.connect();
    }

    return _this;
  }

  _createClass(DDP, [{
    key: "emit",
    value: function emit() {
      var _get2;

      setTimeout((_get2 = _get(_getPrototypeOf(DDP.prototype), "emit", this)).bind.apply(_get2, [this].concat(Array.prototype.slice.call(arguments))), 0);
    }
  }, {
    key: "connect",
    value: function connect() {
      this.socket.open();
    }
  }, {
    key: "disconnect",
    value: function disconnect() {
      /*
       *   If `disconnect` is called, the caller likely doesn't want the
       *   the instance to try to auto-reconnect. Therefore we set the
       *   `autoReconnect` flag to false.
       */
      this.autoReconnect = false;
      this.socket.close();
    }
  }, {
    key: "method",
    value: function method(name, params) {
      var id = (0, _utils.uniqueId)();
      this.messageQueue.push({
        msg: 'method',
        id: id,
        method: name,
        params: params
      });
      return id;
    }
  }, {
    key: "sub",
    value: function sub(name, params) {
      var id = (0, _utils.uniqueId)();
      this.messageQueue.push({
        msg: 'sub',
        id: id,
        name: name,
        params: params
      });
      return id;
    }
  }, {
    key: "unsub",
    value: function unsub(id) {
      this.messageQueue.push({
        msg: 'unsub',
        id: id
      });
      return id;
    }
  }]);

  return DDP;
}(_wolfy87Eventemitter["default"]);

exports["default"] = DDP;