"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _wolfy87Eventemitter = _interopRequireDefault(require("wolfy87-eventemitter"));

var _ejson = _interopRequireDefault(require("ejson"));

require("./mongo-id");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

//  Register mongo object ids */
var Socket = /*#__PURE__*/function (_EventEmitter) {
  _inherits(Socket, _EventEmitter);

  var _super = _createSuper(Socket);

  function Socket(SocketConstructor, endpoint) {
    var _this;

    _classCallCheck(this, Socket);

    _this = _super.call(this);
    _this.SocketConstructor = SocketConstructor;
    _this.endpoint = endpoint;
    _this.rawSocket = null;
    return _this;
  }

  _createClass(Socket, [{
    key: "send",
    value: function send(object) {
      if (!this.closing) {
        var message = _ejson["default"].stringify(object);

        this.rawSocket.send(message); // Emit a copy of the object, as the listener might mutate it.

        this.emit('message:out', _ejson["default"].parse(message));
      }
    }
  }, {
    key: "open",
    value: function open() {
      var _this2 = this;

      /*
       *   Makes `open` a no-op if there's already a `rawSocket`. This avoids
       *   memory / socket leaks if `open` is called twice (e.g. by a user
       *   calling `ddp.connect` twice) without properly disposing of the
       *   socket connection. `rawSocket` gets automatically set to `null` only
       *   when it goes into a closed or error state. This way `rawSocket` is
       *   disposed of correctly: the socket connection is closed, and the
       *   object can be garbage collected.
       */
      if (this.rawSocket) {
        return;
      }

      this.closing = false;
      this.rawSocket = new this.SocketConstructor(this.endpoint);
      /*
       *   Calls to `onopen` and `onclose` directly trigger the `open` and
       *   `close` events on the `Socket` instance.
       */

      this.rawSocket.onopen = function () {
        return _this2.emit('open');
      };

      this.rawSocket.onclose = function () {
        _this2.rawSocket = null;

        _this2.emit('close');

        _this2.closing = false;
      };
      /*
       *   Calls to `onmessage` trigger a `message:in` event on the `Socket`
       *   instance only once the message (first parameter to `onmessage`) has
       *   been successfully parsed into a javascript object.
       */


      this.rawSocket.onmessage = function (message) {
        var object;

        try {
          object = _ejson["default"].parse(message.data);
        } catch (ignore) {
          // Simply ignore the malformed message and return
          return;
        } // Outside the try-catch block as it must only catch JSON parsing
        // errors, not errors that may occur inside a "message:in" event
        // handler


        _this2.emit('message:in', object);
      };
    }
  }, {
    key: "close",
    value: function close() {
      /*
       *   Avoid throwing an error if `rawSocket === null`
       */
      if (this.rawSocket) {
        this.closing = true;
        this.rawSocket.close();
      }
    }
  }]);

  return Socket;
}(_wolfy87Eventemitter["default"]);

exports["default"] = Socket;