"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hashPassword = hashPassword;
exports.isPlainObject = isPlainObject;
exports.uniqueId = uniqueId;

var _sha = _interopRequireDefault(require("crypto-js/sha256"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

var i = 0;

function uniqueId() {
  return (i++).toString();
}

function hashPassword(password) {
  return {
    digest: (0, _sha["default"])(password).toString(),
    // lgtm [js/insufficient-password-hash]
    algorithm: 'sha-256'
  };
} // From Meteor core


var class2type = {};
var toString = class2type.toString;
var hasOwn = class2type.hasOwnProperty;
var support = {}; // Populate the class2type map

_lodash["default"].forEach('Boolean Number String Function Array Date RegExp Object Error'.split(' '), function (name, _i) {
  class2type['[object ' + name + ']'] = name.toLowerCase();
});

function type(obj) {
  if (obj === null) {
    return String(obj);
  }

  return _typeof(obj) === 'object' || typeof obj === 'function' ? class2type[toString.call(obj)] || 'object' : _typeof(obj);
}

function isWindow(obj) {
  return obj !== null && obj === obj.window;
}

function isPlainObject(obj) {
  var key; // Must be an Object.
  // Because of IE, we also have to check the presence of the constructor property.
  // Make sure that DOM nodes and window objects don't pass through, as well

  if (!obj || type(obj) !== 'object' || obj.nodeType || isWindow(obj)) {
    return false;
  }

  try {
    // Not own constructor property must be Object
    if (obj.constructor && !hasOwn.call(obj, 'constructor') && !hasOwn.call(obj.constructor.prototype, 'isPrototypeOf')) {
      return false;
    }
  } catch (e) {
    // IE8,9 Will throw exceptions on certain host objects #9897
    return false;
  } // Support: IE<9
  // Handle iteration over inherited properties before own properties.


  if (support.ownLast) {
    for (key in obj) {
      return hasOwn.call(obj, key);
    }
  } // Own properties are enumerated firstly, so to speed up,
  // if last one is own, then all properties are own.


  for (key in obj) {}

  return key === undefined || hasOwn.call(obj, key);
}