"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Data = _interopRequireDefault(require("../Data"));

var _Call = _interopRequireDefault(require("../Call"));

var _User = _interopRequireDefault(require("./User"));

var _utils = require("../lib/utils");

var _Meteor = _interopRequireDefault(require("../Meteor.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function info(msg) {
  console.info("Acc: ".concat(msg));
}

var AccountsPassword = /*#__PURE__*/_createClass(function AccountsPassword() {
  _classCallCheck(this, AccountsPassword);

  _defineProperty(this, "_hashPassword", _utils.hashPassword);

  _defineProperty(this, "createUser", function (options) {
    var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};
    // Replace password with the hashed password.
    options.password = (0, _utils.hashPassword)(options.password);

    _User["default"]._startLoggingIn();

    (0, _Call["default"])('createUser', options, function (err, result) {
      _Meteor["default"].isVerbose() && info('Accounts.createUser::: err:', err, 'result:', result);

      _User["default"]._endLoggingIn();

      _User["default"]._handleLoginCallback(err, result);

      callback(err);
    });
  });

  _defineProperty(this, "changePassword", function (oldPassword, newPassword) {
    var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function () {};

    // TODO check Meteor.user() to prevent if not logged
    if (typeof newPassword !== 'string' || !newPassword) {
      return callback('Password may not be empty');
    }

    (0, _Call["default"])('changePassword', oldPassword ? (0, _utils.hashPassword)(oldPassword) : null, (0, _utils.hashPassword)(newPassword), function (err, res) {
      callback(err);
    });
  });

  _defineProperty(this, "forgotPassword", function (options) {
    var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};

    if (!options.email) {
      return callback('Must pass options.email');
    }

    (0, _Call["default"])('forgotPassword', options, function (err) {
      callback(err);
    });
  });

  _defineProperty(this, "resetPassword", function (token, newPassword) {
    var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function () {};

    if (!newPassword) {
      return callback('Must pass a new password');
    }

    (0, _Call["default"])('resetPassword', token, (0, _utils.hashPassword)(newPassword), function (err, result) {
      _Meteor["default"].isVerbose() && info('Accounts.resetPassword::: err:', err, 'result:', result);

      if (!err) {
        _User["default"]._loginWithToken(result.token);
      }

      callback(err);
    });
  });

  _defineProperty(this, "onLogin", function (cb) {
    if (_Data["default"]._tokenIdSaved) {
      return cb();
    }

    _Data["default"].on('onLogin', cb);
  });

  _defineProperty(this, "onLoginFailure", function (cb) {
    _Data["default"].on('onLoginFailure', cb);
  });
});

var _default = new AccountsPassword();

exports["default"] = _default;